#include <windows.h>
#include <commctrl.h> 

#include "resource.h" 

LRESULT CALLBACK WindProc (HWND, UINT, WPARAM, LPARAM) ;
BOOL CALLBACK HelpProc(HWND hwnd,UINT Message,WPARAM wParam,LPARAM lParam);

HINSTANCE hInstance;
HDC hdc;

#define HOTKEY_WIN_W WM_USER //+ 10



//---------------------------------------------------------------------------
//							HAUPTFENSTER
//---------------------------------------------------------------------------
int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow)
{
	static TCHAR szAppName[] = TEXT ("DIALOG01") ;

    HWND        hwnd ;		//HWND fr Hauptfenster
	MSG         msg ;		// das message handling heist msg
    WNDCLASS    windclass ; //das Hauptfenster gehrt zu windclass - Klasse

    windclass.style         = CS_HREDRAW | CS_VREDRAW;
    windclass.lpfnWndProc   = WindProc ; 
    windclass.cbClsExtra    = 0 ;
    windclass.cbWndExtra    = DLGWINDOWEXTRA ;    
    windclass.hInstance     = hInstance ;
    windclass.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON));
    windclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
    windclass.hbrBackground = (HBRUSH) (COLOR_BTNFACE + 1) ;
    windclass.lpszMenuName  = "IDM_MENU";
    windclass.lpszClassName = szAppName ;

    if (!RegisterClass (&windclass))
    {
        return 0 ;
    }

    hwnd = CreateDialog (hInstance, szAppName, 0, NULL) ; 

	InitCommonControls();    
    ShowWindow (hwnd, iCmdShow);
	UpdateWindow(hwnd);
    PostMessage(hwnd, WM_COMMAND, IDC_INIT,0); //rufe diese funktion auf -> init()   
    while (GetMessage (&msg, NULL, 0, 0)) 
    {
        TranslateMessage (&msg) ;
        DispatchMessage (&msg) ;
    }
    return msg.wParam ;
}

void Init ( HWND hwnd)
{
}


//Abfragen zum im Hauptfenster befindlichen Knpfe + Buttons etc. ...
LRESULT CALLBACK WindProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
    {
		case WM_CREATE:
		{
			// ALT = 1; CRTL = 2; SHIFT= 4; WIN = 8
			// CRTL+ALT = 3
			// ALT+SHIFT = 5
			// ------------------------------------------
			// 8  is the modifier flag 
			// 87 is the keycode for 'W'
			// the number accounding to ascii-table ...

			if(!RegisterHotKey(hwnd, HOTKEY_WIN_W, 8, 87))
				MessageBox(hwnd, "Fehler beim registrieren des Hotkeys!", "Error", MB_OK);

		}
		break;



		
		case WM_DESTROY:
			PostQuitMessage(0);
		break;



		case WM_COMMAND:
        {
			switch( LOWORD( wParam ) )
            {
                case IDC_INIT:
                {
					Init(hwnd);					
			    }
                break;



				case IDC_BUTTON1:
					PostMessage(hwnd, WM_HOTKEY, HOTKEY_WIN_W,0);
				break;
   			}
        }
        return 0 ;



		case WM_HOTKEY: 
          switch (wParam) 
          { 
            case HOTKEY_WIN_W: 
               MessageBox(hwnd, "Win + W was pressed.", "Hotkey", NULL); 
            break; 
         } 
         break;



	}
    return DefWindowProc (hwnd, message, wParam, lParam) ;
}
